<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on July 2, 2008 at 2:44:22 pm</time-stamp>


<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>clients interaction</category>

<body package="PV-CME-Core" selector="lastScavengeableTuplePositionEarlierThan:">lastScavengeableTuplePositionEarlierThan: aNumber 
	
	| pos |
	pos := 
		self clients 
			inject: nil
			into: 
				[:lastPos :eachClient | 
				eachClient firstNeededTupleId 
					ifNil: [lastPos]
					ifNotNil: 
						[:num | 
						lastPos 
							ifNil: [num - 1]
							ifNotNil: [num - 1 min: lastPos]]].
	(pos notNil and: [self shouldStore]) 
		ifTrue: 
			[[pos &gt; 0 and: [(self bufferedTuples at: pos) timestamp &gt;= aNumber]] 
				whileTrue: [pos := pos - 1]]
		ifFalse: 
			[(self isPeriodicTimeSeries or: [pos isNil]) 
				ifTrue: 
					[pos := self bufferedTuples size.
					[pos &gt; 0 and: [(self bufferedTuples at: pos) timestamp &gt;= aNumber]] 
						whileTrue: [pos := pos - 1]]].
	^pos max: 0</body>
</methods>

</st-source>
